from __future__ import with_statement
import os, sys
from thread import get_ident

locks = None
if os.name == 'nt':
    try:
        from mext.threads.win import locks, events
    except ImportError:
        pass

if locks is None:
    from mext.threads.generic import locks, events

sys.modules['mext.threads.locks'] = locks
sys.modules['mext.threads.events'] = events

from mext.threads.locks import SimpleLock, TimeoutLock, RLock
from mext.threads.events import Flag
from mext.threads.sync import *
from mext.threads.queues import *
from mext.threads.new_thread import Thread

__all__ = [
    'Thread', 'is_main_thread',
    'SimpleLock', 'TimeoutLock', 'RLock',
    #'Event', 'Flag', 'PendingResult', 'Resource',
    'Queue', #'PriorityQueue', 'LifoQueue', 'Empty',
]


assert Thread.get().name == 'MainThread'
main_thread_id = get_ident()

def is_main_thread():
    return get_ident() == main_thread_id










